package graph;

import java.util.ArrayList;
import java.util.Vector;
import java.util.HashSet;


public class MyGraph {
	
	Vector<HashSet<Integer>> cityGroups = new Vector<HashSet<Integer>>();
	ArrayList<Highway> highways = new ArrayList<Highway>();
	
	public HashSet<Integer> getCityGroup(int city){
		
        for (HashSet<Integer> cityGroup : cityGroups) {
            if (cityGroup.contains(city)) {
                return cityGroup;
            }
        }
        return null;
    }
	
	public ArrayList<Highway> getHighways(){
        return highways;
    }
	
	public void insertHighway(Highway hw){
		
		int cityA = hw.getCityA();
        int cityB = hw.getCityB();
        HashSet<Integer> cityGroupA = getCityGroup(cityA);
        HashSet<Integer> cityGroupB = getCityGroup(cityB);
        
        if (cityGroupA == null) {
            highways.add(hw);
            if (cityGroupB == null) {
                HashSet<Integer> newCityGroup = new HashSet<Integer>();
                newCityGroup.add(cityA);
                newCityGroup.add(cityB);
                cityGroups.add(newCityGroup);
            }
            else {
                cityGroupB.add(cityA);           
            }
        }
        else {
            if (cityGroupB == null) {
                cityGroupA.add(cityB);
                highways.add(hw);
            }
            else if (cityGroupA != cityGroupB) {
                cityGroupA.addAll(cityGroupB);
                cityGroups.remove(cityGroupB);
                highways.add(hw);
            }
        }
	}
}
